/*
 * 2048
 *
 * Created: 5/22/2018 11:59:30
 * Author : Andrei
 */ 
#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include "ili9341.h"
#include "ili9341gfx.h"
#include <time.h>

#define NUM_NOTE		8
#define n				4
#define marime_c		16
#define marime_s		16
#define offset			100
#define y_len			32

int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

int mat[n][n], rez[n][n];
int valid, win, scor, scor_rez;
int bloc, end;

void ADC_init(void)
{
	ADMUX = 0;
	ADMUX |= (1 << REFS0);         // AVCC with external capacitor at AREF pin
	ADCSRA = 0;
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
	ADCSRA |= (1 << ADEN);         // enable ADC
}

uint16_t ADC_get(uint8_t channel)
{
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;
	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));

	return ADC;
}

void speaker_reda(int nota) {
	int perioada_nota = 1000000l / frecventa_nota[nota];
	int i;
	
	PORTD |= (1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	PORTD &= ~(1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}

void init(){
	//led de pe placa
	DDRD |= (1 << PD7);
	
	//speaker
	DDRD |= (1 << PD5);
	PORTD &= ~(1 << PD5);
	
	//set si aprind led lcd
	DDRB |= (1 << PB1);
	PORTB |= (1 << PB1);
	
	//buton joystick
	DDRA &= ~(1 << PA2);
	PORTA |= (1 << PA2);
}

void copiere_mat(int way){//Functia scrie in matricea b valorile
	int i,j;			//matricii a
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			if (way == 0)
				rez[i][j]=mat[i][j];
			else
				mat[i][j]=rez[i][j];
}

void aleatoriu(int *element){	//generarea de 2 sau 4 cu o pondere mai mare
	int ele;		//de generare a lui 2
	ele=rand()%10;
	if( ele == 9)
	ele=4;
	else
	ele=2;
	*element=ele;
}

void initializare_mat(){	//se initializeaza matricea a cu 2
	int ele,lin1,col1,lin2,col2,i,j;	//numere diferite de 0
	
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			mat[i][j]=0;
			
	lin1=rand()%n;
	col1=rand()%n;
	lin2=rand()%n;
	col2=rand()%n;
	while( lin1 == lin2 && col1 == col2){
		lin2=rand()%n;
		col2=rand()%n;
	}
	aleatoriu(&ele);
	mat[lin1][col1]=ele;
	aleatoriu(&ele);
	mat[lin2][col2]=ele;
}

int verificare(){	//se verificada daca mai exista mutari
	int i,j;		//valabile pentru matricea mat
	for(i=0;i<n-1;i++){
		for(j=0;j<n-1;j++)
			if( mat[i][j] == mat[i+1][j] || mat[i][j] == mat[i][j+1]
			|| mat[i+1][j] == 0 || mat[i][j] == 0 || mat[i][j+1] ==0){
				return 1;
				break;
			}
		if( mat[i][j] == mat[i+1][j] || mat[i+1][j] == 0 ){
			return 1;
			break;
		}
	}
	for(j=0;j<n-1;j++)
		if( mat[i][j] == mat[i][j+1] || mat[i][j+1] == 0 ){
			return 1;
			break;
		}
	return 0;
}

void pas_dreapta(){
	int i,j,k,l;			//modifica matricea a conform
							//unei mutari spre dreapta
							//variabila win
							//care verifica daca apare numarul 2048
							//si o valid care verifica daca a aprut vreo
							//schimbare in matrice
	valid = 0;
	for(i=0;i<n;i++){
		for(j=n-1;j>0;j--){
			k=j;
			if( mat[i][j] == 0 ){
				while( k >= 0 ){
					if( mat[i][k] ){
						mat[i][j]=mat[i][k];
						mat[i][k]=0;
						j++;
						valid=1;
						break;
					}
					else
					k--;
				}
			}
			else{
				k=j-1;
				while( k >= 0 && mat[i][k] == 0 )
				k--;
				if( k >= 0 )
				if( mat[i][j] == mat[i][k] ){
					mat[i][j] = mat[i][j]*2;
					if( mat[i][j] == 2048 )
					win=1;
					scor=scor+mat[i][j];
					mat[i][k]=0;
					valid=1;
				}
			}
		}
	}
}

void pas_stanga(){ //produce
	int i,j,l,k;		//modificarile pentru mutarea
									//la stanga
	valid = 0;
	for(i=0;i<n;i++){
		for(j=0;j<n-1;j++){
			k=j+1;
			if( mat[i][j] == 0 ){
				while( k < n ){
					if( mat[i][k] ){
						mat[i][j]=mat[i][k];
						mat[i][k]=0;
						j--;
						valid=1;
						break;
					}
					else
					k++;
				}
			}
			else{
				k=j+1;
				while( k < n && mat[i][k] == 0 )
				k++;
				if( k < n )
				if( mat[i][j] == mat[i][k] ){
					mat[i][j]=mat[i][j]*2;
					if( mat[i][j] == 2048 )
					win=1;
					scor=scor+mat[i][j];
					mat[i][k]=0;
					valid=1;
				}
			}
		}
	}
}

void pas_jos(){
	int i,j,k,l;	//produce modificarile pentru
					//mutarea in jos
	valid = 0;
	for(j=0;j<n;j++){
		for(i=n-1;i>0;i--){
			k=i;
			if( mat[i][j] == 0 ){
				while( k >= 0 ){
					if( mat[k][j] ){
						mat[i][j]=mat[k][j];
						mat[k][j]=0;
						i++;
						valid=1;
						break;
					}
					else
					k--;
				}
			}
			else{
				k=i-1;
				while( k >= 0 && mat[k][j] == 0 )
				k--;
				if( k >= 0 )
				if( mat[i][j] == mat[k][j] ){
					mat[i][j]=mat[i][j]*2;
					if( mat[i][j] == 2048 )
						win=1;
					scor=scor+mat[i][j];
					mat[k][j]=0;
					valid=1;
				}
			}
		}
	}
}

void pas_sus(){
	int i,j,k,l;				//produce modificarile pentru
								//mutarea in sus
	valid = 0;
	for(j=0;j<n;j++){
		for(i=0;i<n-1;i++){
			k=i+1;
			if( mat[i][j] == 0 ){
				while( k < n ){
					if( mat[k][j] ){
						mat[i][j]=mat[k][j];
						mat[k][j]=0;
						i--;
						valid=1;
						break;
					}
					else
					k++;
				}
			}
			else{
				k=i+1;
				while( k < n && mat[k][j] == 0 )
				k++;
				if( k < n )
				if( mat[i][j] == mat[k][j] ){
					mat[i][j]=mat[i][j]*2;
					if( mat[i][j] == 2048 )
						win=1;
					scor=scor+mat[i][j];
					mat[k][j]=0;
					valid=1;
				}
			}
		}
	}
}

void game(int x, int y){
	int i,j, plin, ele, lin, col ;
	int miscare;
	
	miscare  = 0;
	if( x == 1023 && (y < 600 && y > 400 )){
		copiere_mat(0);
		scor_rez = scor;
		pas_dreapta();
		miscare = 1;
	}
	if( x == 0 && (y < 600 && y > 400 )){
		copiere_mat(0);
		scor_rez = scor;
		pas_stanga();
		miscare = 1;
	}
	
	if( y == 1023 && (x < 600 && x > 400 )){
		copiere_mat(0);
		scor_rez = scor;
		pas_jos();
		miscare = 1;
	}
	if( y == 0 && (x < 600 && x > 400 )){
		copiere_mat(0);
		scor_rez = scor;
		pas_sus();
		miscare = 1;
	}
	
	if( win == 1 ){
		end = 1;
		win_meniu();
		return;	
	}
	
	if(verificare() == 0){
		end = 1;
		lost_meniu();
		return;
	}

	if(miscare == 1 ){
		plin = 0;
		for(i=0;i<n;i++)
			for(j=0;j<n;j++)
				if( mat[i][j] == 0 ){
					plin=1;
					break;
					break;
				}
		if( valid == 1){
			if( plin == 1 ){
				do{
					lin=rand()%n;
					col=rand()%n;
				}while( mat[lin][col] != 0 );
				aleatoriu(&ele);
				mat[lin][col]=ele;
			}
		}
		afisare();
		for(i = 0; i < NUM_NOTE; i++)
			speaker_reda(i);
		_delay_ms(250);
	}
}

void set_color(int lin, int col){
	switch(mat[lin][col]){
		case 2:
			ili9341_settextcolour(BLACK,LIGHTGREY);
			break;
		case 4:
			ili9341_settextcolour(BLACK,DARKGREY);
			break;
		case 8:
			ili9341_settextcolour(BLACK,ORANGE);
			break;
		case 16:
			ili9341_settextcolour(WHITE,BLUE);
			break;
		case 32:
			ili9341_settextcolour(WHITE,OLIVE);
			break;
		case 64:
			ili9341_settextcolour(WHITE,RED);
			break;
		case 128:
			ili9341_settextcolour(WHITE,PURPLE);
			break;
		case 256:
			ili9341_settextcolour(BLACK,CYAN);
			break;
		case 512:
			ili9341_settextcolour(WHITE,MAGENTA);
			break;
		case 1024:
			ili9341_settextcolour(BLACK,GREENYELLOW);
			break;
		case 2048:
			ili9341_settextcolour(BLACK,YELLOW);
			break;
		default:
			ili9341_settextcolour(WHITE,NAVY);
			break;
	}
}

void numar(int i,int j){
	int nr, cifra, h;
	char cifra_c;
	nr = mat[i][j];
	h = 0;
	
	while( nr > 0){
		cifra = nr % 10;
		ili9341_setcursor(j*bloc + (n-h) * marime_c,offset + i * y_len);
		cifra_c = cifra +'0';
		ili9341_write(cifra_c);
		nr = nr / 10;
		h++;
	}
}

void afisare(){
	int i, j, aux, cifra, h;
	char cifra_c;
	
	ili9341_setRotation(1);
	ili9341_settextsize(5);
	
	ili9341_settextcolour(WHITE,NAVY);
	h = 0;
	ili9341_setcursor(0,20);
	ili9341_write('S');
	ili9341_setcursor(30,20);
	ili9341_write('c');
	ili9341_setcursor(60,20);
	ili9341_write('o');
	ili9341_setcursor(90,20);
	ili9341_write('r');
	if( scor == 0 ) {
		ili9341_setcursor(270,20);
		ili9341_write('0');
	} else {
		aux = scor;
		while( aux > 0){
			cifra = aux % 10;
			ili9341_setcursor(120 + (5-h) * 30,20);
			cifra_c = cifra +'0';
			ili9341_write(cifra_c);
			aux = aux / 10;
			h++;
		}
	}
	ili9341_settextsize(3);
	for(i = 0; i < n; i++){
		for(j = 0; j < n; j++){
			ili9341_fillrect(j*bloc+16,offset + i * y_len,64,24,WHITE);
			set_color(i,j);
			numar(i,j);
		}
	}
}

void win_meniu(){
	ili9341_clear(BLACK);
	ili9341_setRotation(1);
	ili9341_settextsize(5);
	ili9341_settextcolour(WHITE,NAVY);
	ili9341_setcursor(0,20);
	ili9341_write('Y');
	ili9341_setcursor(30,20);
	ili9341_write('o');
	ili9341_setcursor(60,20);
	ili9341_write('u');
	ili9341_setcursor(90,20);
	ili9341_write(' ');
	ili9341_setcursor(120,20);
	ili9341_write('w');
	ili9341_setcursor(150,20);
	ili9341_write('o');
	ili9341_setcursor(180,20);
	ili9341_write('n');
	ili9341_setcursor(210,20);
	ili9341_write('!');
	
	ili9341_setcursor(0,60);
	ili9341_write('P');
	ili9341_setcursor(30,60);
	ili9341_write('r');
	ili9341_setcursor(60,60);
	ili9341_write('e');
	ili9341_setcursor(90,60);
	ili9341_write('s');
	ili9341_setcursor(120,60);
	ili9341_write('s');
	
	ili9341_setcursor(30,100);
	ili9341_write('J');
	ili9341_setcursor(60,100);
	ili9341_write('o');
	ili9341_setcursor(90,100);
	ili9341_write('y');
	ili9341_setcursor(120,100);
	ili9341_write('s');
	ili9341_setcursor(150,100);
	ili9341_write('t');
	ili9341_setcursor(180,100);
	ili9341_write('i');
	ili9341_setcursor(210,100);
	ili9341_write('c');
	ili9341_setcursor(240,100);
	ili9341_write('k');
	
	
	ili9341_setcursor(30,140);
	ili9341_write('f');
	ili9341_setcursor(60,140);
	ili9341_write('o');
	ili9341_setcursor(90,140);
	ili9341_write('r');
	
	ili9341_setcursor(30,180);
	ili9341_write('r');
	ili9341_setcursor(60,180);
	ili9341_write('e');
	ili9341_setcursor(90,180);
	ili9341_write('s');
	ili9341_setcursor(120,180);
	ili9341_write('t');
	ili9341_setcursor(150,180);
	ili9341_write('a');
	ili9341_setcursor(180,180);
	ili9341_write('r');
	ili9341_setcursor(210,180);
	ili9341_write('t');
	ili9341_setcursor(240,180);
	ili9341_write('!');
}

void lost_meniu(){
	ili9341_clear(BLACK);
	ili9341_setRotation(1);
	ili9341_settextsize(5);
	ili9341_settextcolour(WHITE,NAVY);
	ili9341_setcursor(0,20);
	ili9341_write('Y');
	ili9341_setcursor(30,20);
	ili9341_write('o');
	ili9341_setcursor(60,20);
	ili9341_write('u');
	ili9341_setcursor(90,20);
	ili9341_write(' ');
	ili9341_setcursor(120,20);
	ili9341_write('l');
	ili9341_setcursor(150,20);
	ili9341_write('o');
	ili9341_setcursor(180,20);
	ili9341_write('s');
	ili9341_setcursor(210,20);
	ili9341_write('t');
	ili9341_setcursor(240,20);
	ili9341_write('!');
	
	ili9341_setcursor(0,60);
	ili9341_write('P');
	ili9341_setcursor(30,60);
	ili9341_write('r');
	ili9341_setcursor(60,60);
	ili9341_write('e');
	ili9341_setcursor(90,60);
	ili9341_write('s');
	ili9341_setcursor(120,60);
	ili9341_write('s');
	
	ili9341_setcursor(30,100);
	ili9341_write('J');
	ili9341_setcursor(60,100);
	ili9341_write('o');
	ili9341_setcursor(90,100);
	ili9341_write('y');
	ili9341_setcursor(120,100);
	ili9341_write('s');
	ili9341_setcursor(150,100);
	ili9341_write('t');
	ili9341_setcursor(180,100);
	ili9341_write('i');
	ili9341_setcursor(210,100);
	ili9341_write('c');
	ili9341_setcursor(240,100);
	ili9341_write('k');
	
	
	ili9341_setcursor(30,140);
	ili9341_write('f');
	ili9341_setcursor(60,140);
	ili9341_write('o');
	ili9341_setcursor(90,140);
	ili9341_write('r');
	
	ili9341_setcursor(30,180);
	ili9341_write('r');
	ili9341_setcursor(60,180);
	ili9341_write('e');
	ili9341_setcursor(90,180);
	ili9341_write('s');
	ili9341_setcursor(120,180);
	ili9341_write('t');
	ili9341_setcursor(150,180);
	ili9341_write('a');
	ili9341_setcursor(180,180);
	ili9341_write('r');
	ili9341_setcursor(210,180);
	ili9341_write('t');
	ili9341_setcursor(240,180);
	ili9341_write('!');
}

int main(void)
{
	int i;
	int x, y;
	srand(time(NULL));
	init();
	initializare_mat();
	copiere_mat(0);
	ADC_init();
	ili9341_init();
	ili9341_clear(BLACK);
	_delay_ms(100);
	bloc = 4 * marime_c + marime_s;
	afisare();
	while(1){
		x = ADC_get(4);
		y = ADC_get(3);
		if(end != 1 ){
			game(x,y);
			//undo
			if((PINA & (1 << PA2)) == 0){
				copiere_mat(1);
				scor = scor_rez;
				afisare();
			}
		}
		else {
			if ((PINA & (1 << PA2)) == 0){
				end = 0;
				win = 0;
				scor = 0;
				scor_rez = 0;
				initializare_mat();
				copiere_mat(0);
				ili9341_clear(BLACK);
				_delay_ms(300);
				afisare();
			}			
		}
	}
}

